/* Audio CD abspielen mit MCI-Befehlen */

arg cmd list  /* cmd und trackliste holen */ 
select
 when pos('PLAY',cmd) = 1 then
  do
   call Init ; call GetTracks
   if call ParseList() = 0 then
    do   /* komplette CD abspielen */
     call send('seek cd to start wait')
     call send('play cd wait')
    end
   else  /* nur angegebene Track abspielen */
    do i=1 to tracklist.0
      start=tracklist.i ; end=start+1        
      call send('seek cd to 'position.start' wait')
      call send('play cd to 'position.end' wait')
    end
   call ende
  end
 when pos('INFO',cmd) = 1 then
  do         /* CD-Infos ausgeben */
   call Init ; call GetTracks
   say ' Track  Lnge'   
   do i=1 to position.0
    j = i+1
    time = position.j - position.i
    say RIGHT(i,4)'   ' ConvTime(time)
   end
   call Ende
  end
 otherwise  call Aufruf
end

ende:  /* Programm beenden */
call send ('close cd wait') ; call mciRxExit
exit(0)

Init:  /* MCI Schnitstelle initialisieren */
rc = RXFUNCADD('mciRxInit','MCIAPI','mciRxInit')
InitRC = mciRxInit()
call send ('open cdaudio01 alias cd wait')
call send ('status cd mode wait')
return

send:  /* Senden eines MCI Befehls */
arg befehl
rc = mciRxSendString(befehl , 'RetStr', '0', '0')
if rc <> 0 then   /* Fehler aufgetreten ? */
 do
  err = mciRxGetErrorString(rc,'RetStr')
  say ' Fehler beim Zugriff aus das CD Laufwerk !!'
  say '  Code : ' rc ' , ' RetStr
  call mciRxSendString 'close cd wait','RetStr','0','0'
  call mciRxExit
  exit(1)
 end
return RetStr

GetTracks:  /* Einlesen der Tracks und ihrer Daten */
nr_tracks = send('status cd number of tracks wait')
if nr_tracks = 0 then
 do
  say 'eingelegte CD ist keine Audio-CD !!'
  call ende
 end
position.0 = nr_tracks
call send('set cd time format ms wait')
max = nr_tracks+1
position.max = send('status cd length wait')
do track = 1 to nr_tracks
 position.track = send('status cd position track 'track' wait')
end 
return

ConvTime:
arg time
min = time % 60000 ; time = time - (min * 60000)
sec = time % 1000
return min':'RIGHT(sec,2,0)

ParseList:  /* Auswerten der angegebenen Track Liste */
n = 0
do forever
 parse var list track rest
 if track ='' then leave
 if DATATYPE(track,W) = 1 then
 do
  if (track > 0) & (track-1 < position.0) then  /* gltige Nr. ? */
  do
   n = n+1 ; tracklist.n = track  /* Track eintragen */
  end
 end
 list = rest    /* betrachte Rest der Liste */
end
if n = 0 then     /* keine korrekten Tracks angegeben ? */
do
 tracklist.0 = position.0
 do i=1 to tracklist.0     /* dann alle Tracks nehmen */
  tracklist.i = i
 end
end
else tracklist.0 = n
return n

Aufruf:
 say 'REXX-AudioCD Player'
 say 'Aufruf : audio_cd <cmd>'
 say
 say ' optionen  play - Abspielen der kompletten CD'
 say '           play <track1 ... trackN> - Abspielen der angegebenene Tracks'
 say '           info - Ausgabe von Infos der eingelegten CD'
 exit (1)
RETURN